; 
    include \masm32\include\masm32rt.inc
; 

comment * --------------------------------------------------------

                         Build this utility with
                       "CONSOLE ASSEMBLE AND LINK"

        This utility recurses the directory tree from its current
        location and changes the case of all file names to lower
        case.

        -------------------------------------------------------- *

    Find_Files  PROTO :DWORD
    change_case PROTO :DWORD

    .code

start:
   
; 

    call main

    exit

; 

main proc

    fn Find_Files,"*.*"

    ret

main endp

; 

Find_Files proc ppatn:DWORD

    LOCAL hSrch :DWORD
    LOCAL wfd   :WIN32_FIND_DATA
    LOCAL pbuf  :DWORD
    LOCAL buffer[260]:BYTE

    mov pbuf, ptr$(buffer)

    mov hSrch, rv(FindFirstFile,ppatn,ADDR wfd)
        invoke SetFileAttributes,ADDR wfd.cFileName,FILE_ATTRIBUTE_NORMAL	
    .if hSrch != INVALID_HANDLE_VALUE
      lea eax, wfd.cFileName
      switch$ eax
        case$ "."                           ; bypass current directory character
          jmp @F
      endsw$
      .if wfd.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY
        chdir ADDR wfd.cFileName
        fn Find_Files,ppatn                 ; recurse to next directory level
      .endif
      invoke change_case,ADDR wfd.cFileName

    @@:
      test rv(FindNextFile,hSrch,ADDR wfd), eax
      jz close_file
      invoke SetFileAttributes,ADDR wfd.cFileName,FILE_ATTRIBUTE_NORMAL	
      lea eax, wfd.cFileName
      switch$ eax
        case$ ".."                          ; bypass previous directory characters
          jmp @F
      endsw$
      .if wfd.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY
        chdir ADDR wfd.cFileName
        fn Find_Files,ppatn                 ; recurse to next directory level
      .endif
      invoke change_case,ADDR wfd.cFileName

    @@:                                     ; loop through the rest
      test rv(FindNextFile,hSrch,ADDR wfd), eax
      jz close_file
      invoke SetFileAttributes,ADDR wfd.cFileName,FILE_ATTRIBUTE_NORMAL	
      invoke change_case,ADDR wfd.cFileName
      .if wfd.dwFileAttributes == FILE_ATTRIBUTE_DIRECTORY
        chdir ADDR wfd.cFileName
        fn Find_Files,ppatn                 ; recurse to next directory level
      .endif
      jmp @B

    close_file:
      invoke FindClose,hSrch
    .endif

    chdir ".."                              ; drop back to next lower directory

    ret

Find_Files endp

; 

change_case proc fname:DWORD

    LOCAL pbuf  :DWORD
    LOCAL buffer[260]:BYTE

    mov pbuf, ptr$(buffer)

    invoke MoveFile,fname,lcase$(fname)     ; rename file to lower case form

    invoke GetCurrentDirectory,260,pbuf
    print lcase$(pbuf),"\"
    print lcase$(fname),13,10               ; display the lower case name

    ret

change_case endp

; 

end start





















